#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void waiting(int, char);

int main()
{
    int d=5;
    puts("I/Oのリクエストと実際に出力されるタイミングが、バッファリングによって受ける影響を観察します。");
    puts("このソースコードを読んで、プログラムが意図していることと、実行結果とを見比べてください。\n");
    puts("標準出力は、バッファリングされたI/Oです。標準エラー出力は、バッファリングされません。");
    puts("waiting関数内のカウントダウン(3秒)表示は、標準エラー出力です。\n");
    puts("改行によってバッファがフラッシュされることを確認してください。(逆に改行がなければ、バッファがいっぱいになるまでは、出力されません。)");
    puts("また、カウントダウン中にInterrupt(Control-Cを入力)して、バッファにある情報がフラッシュされるのか、されないのかも確認してみましょう。");

    printf("\n%d秒後に実験開始です。\n\n",d);
    waiting(d,'y');
    puts("Start");

    printf(" 1:%s\n", "はじめの文字列。改行あり");
    waiting(3, '\0');
    printf(" 2:%s", "2つめの文字列。改行なし");
    waiting(3, '\0');
    printf(" 3:\n%s\n", "3つめの文字列。この前後で改行");
    waiting(3, '\0');
    printf(" 4:%s", "4つめの文字列。改行なし");
    waiting(3, '\0');
    printf(" 5:%s", "5つめの文字列。改行なし");
    waiting(3, '\0');
    exit(0);
}

void waiting(int i, char c) {
    for (; i>0; i--) {
        sleep(1);
        if (c == '\0') fprintf(stderr," %2d",i);
    }
    if (c == '\0') fprintf(stderr, "\n");
}
